// sample1Dlg.h : header file
//

#if !defined(AFX_SAMPLE1DLG_H__52C69E85_2D8E_4E39_AC96_E376BEF35013__INCLUDED_)
#define AFX_SAMPLE1DLG_H__52C69E85_2D8E_4E39_AC96_E376BEF35013__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// CSample1Dlg dialog

class CSample1Dlg : public CDialog
{
// Construction
public:
	CSample1Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSample1Dlg)
	enum { IDD = IDD_SAMPLE1_DIALOG };
	CButton	m_set7;
	CButton	m_set6;
	CButton	m_set5;
	CButton	m_set4;
	CButton	m_set3;
	CButton	m_set2;
	CButton	m_set1;
	CButton	m_set0;
	CSliderCtrl	m_slider7;
	CSliderCtrl	m_slider6;
	CSliderCtrl	m_slider5;
	CSliderCtrl	m_slider4;
	CSliderCtrl	m_slider3;
	CSliderCtrl	m_slider2;
	CSliderCtrl	m_slider1;
	CSliderCtrl	m_slider0;
	CProgressCtrl	m_bar7;
	CProgressCtrl	m_bar6;
	CProgressCtrl	m_bar5;
	CProgressCtrl	m_bar4;
	CProgressCtrl	m_bar3;
	CProgressCtrl	m_bar2;
	CProgressCtrl	m_bar1;
	CProgressCtrl	m_bar0;
	CEdit	m_resolution7;
	CEdit	m_resolution6;
	CEdit	m_resolution5;
	CEdit	m_resolution4;
	CEdit	m_resolution3;
	CEdit	m_resolution2;
	CEdit	m_resolution1;
	CEdit	m_resolution0;
	CButton	m_rst7;
	CButton	m_rst6;
	CButton	m_rst5;
	CButton	m_rst4;
	CButton	m_rst3;
	CButton	m_rst2;
	CButton	m_rst1;
	CButton	m_rst0;
	CEdit	m_reading7;
	CEdit	m_reading6;
	CEdit	m_reading5;
	CEdit	m_reading4;
	CEdit	m_reading3;
	CEdit	m_reading2;
	CEdit	m_reading1;
	CEdit	m_reading0;
	CStatic	m_paintBox7;
	CStatic	m_paintBox6;
	CStatic	m_paintBox5;
	CStatic	m_paintBox4;
	CStatic	m_paintBox3;
	CStatic	m_paintBox2;
	CStatic	m_paintBox1;
	CStatic	m_paintBox0;
	CComboBox	m_mult0;
	CButton	m_initBtn;
	CButton	m_goBtn;
	CEdit	m_addr;
	CString	m_currentRPM0;
	CString	m_currentRPM1;
	CString	m_currentRPM2;
	CString	m_currentRPM3;
	CString	m_currentRPM4;
	CString	m_currentRPM5;
	CString	m_currentRPM6;
	CString	m_currentRPM7;
	CString	m_maxRpmBarLabel0;
	CString	m_maxRpmBarLabel1;
	CString	m_maxRpmBarLabel2;
	CString	m_maxRpmBarLabel3;
	CString	m_maxRpmBarLabel4;
	CString	m_maxRpmBarLabel5;
	CString	m_maxRpmBarLabel6;
	CString	m_maxRpmBarLabel7;
	CComboBox	m_mult1;
	CComboBox	m_mult2;
	CComboBox	m_mult3;
	CComboBox	m_mult4;
	CComboBox	m_mult5;
	CComboBox	m_mult6;
	CComboBox	m_mult7;
	CString	m_sliderLabel0;
	CString	m_sliderLabel1;
	CString	m_sliderLabel2;
	CString	m_sliderLabel3;
	CString	m_sliderLabel4;
	CString	m_sliderLabel5;
	CString	m_sliderLabel6;
	CString	m_sliderLabel7;
	//}}AFX_DATA

	// Data:
	bool timerRunning;
	unsigned short baseAddr;
	int previous_readings[8], currentReadings[8], currentRes[8];

	// Functions;
	void doPaintBox(int channel);
	void changeResolution(int channel);
	void resetCount(int channel);

	// Arrays of dlg controls:
	CProgressCtrl *progressBars[8];
	CString *currentRPMs[8], *maxRPMs[8], *sliderLabels[8];
	CComboBox *multBoxes[8];
	CStatic *paintBoxes[8];
	CEdit *readings[8], *resolutions[8];
	CButton *resetBtns[8], *setBtns[8];
	CSliderCtrl *sliders[8];


	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSample1Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL
	
	
// Implementation

protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSample1Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnInitBtn();
	afx_msg void OnGoBtn();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSet0();
	afx_msg void OnSet1();
	afx_msg void OnSet2();
	afx_msg void OnSet3();
	afx_msg void OnSet4();
	afx_msg void OnSet5();
	afx_msg void OnSet6();
	afx_msg void OnSet7();
	afx_msg void OnReset0();
	afx_msg void OnReset1();
	afx_msg void OnReset2();
	afx_msg void OnReset3();
	afx_msg void OnReset4();
	afx_msg void OnReset5();
	afx_msg void OnReset6();
	afx_msg void OnReset7();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAMPLE1DLG_H__52C69E85_2D8E_4E39_AC96_E376BEF35013__INCLUDED_)
